function x = gc(b, psf, passi,reg)
% function x = gc(b, psf, passi)
% risolve il sistema ai minimi quadrati Hx=b col gradiente
% coniugato
% b: termine noto del sistema (immagine sfocata) come matrice mxn
% psf: point-spread function che definisce la matrice H del sistema
% la matrice H ha piu’ colonne che righe
% passi: numero di iterazioni del metodo del gradiente coniugato
% Viene usata la seguente formula
% x = H^T (HH^T)^{-1}b, dove il vettore
% y = (HH^T )^{-1}b viene calcolato risolvendo
% il sistema (HH^T)y=b col metodo del gradiente coniugato



% calcolo la psf associata a H^T
psft = psf(end:-1:1, end:-1:1);

% dimensioni degli oggetti
[mb,nb] = size(b);
% inizio le iterazioni di GC
r = b;
y = zeros(mb,nb);

for iter=1:passi

 rho = sum(sum(r.*r));
if iter==1
p = r;
else
beta = rho/rhop; %rhop sta per rho precedente, che viene fissato, perché poi rho viene riaggiornato
p = r + beta*p;
end

tmp = conv2(p, psft, 'full');
q = conv2(tmp, psf, 'valid');
q=q+reg*p;
alpha = rho/sum(sum(p.*q));
y = y + alpha*p;
r = r-alpha * q;
rhop = rho;
end
x = conv2(y, psft, 'full');

k=size(psf);
k=(k(1)-1)/2;
x=togli(x,k);

end
